/*
 *  ircd-ratbox: A slightly useful ircd.
 *  spy_stats_notice.c: Sends a notice when someone uses STATS.
 *
 *  Copyright (C) 2002 by the past and present ircd coders, and others.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  $Id: spy_stats_notice.c,v 1.18 2004/03/07 18:13:22 leeh Exp $
 */
#include "stdinc.h"
#include "modules.h"
#include "hook.h"
#include "client.h"
#include "ircd.h"
#include "send.h"

int show_stats(struct hook_spy_data *);

mapi_hfn_list_av1 stats_hfnlist[] = {
	{"doing_stats", (hookfn) show_stats},
	{NULL, NULL}
};

DECLARE_MODULE_AV1(stats_spy, NULL, NULL, NULL, NULL, stats_hfnlist, "$Revision: 1.18 $");

int
show_stats(struct hook_spy_data *data)
{
	if((data->statchar == 'L') || (data->statchar == 'l'))
	{
		if(data->name != NULL)
			sendto_realops_flags(UMODE_SPY, L_ALL,
					     "STATS %c requested by %s (%s@%s) [%s] on %s",
					     data->statchar,
					     data->source_p->name,
					     data->source_p->username,
					     data->source_p->host,
					     data->source_p->user->server, data->name);
		else
			sendto_realops_flags(UMODE_SPY, L_ALL,
					     "STATS %c requested by %s (%s@%s) [%s]",
					     data->statchar,
					     data->source_p->name,
					     data->source_p->username,
					     data->source_p->host, data->source_p->user->server);
	}
	else
	{
		sendto_realops_flags(UMODE_SPY, L_ALL,
				     "STATS %c requested by %s (%s@%s) [%s]",
				     data->statchar, data->source_p->name, data->source_p->username,
				     data->source_p->host, data->source_p->user->server);
	}

	return 0;
}
